# Sentry Toolkit
This project was born out of a simple marketing request.  Basically along the lines of "how can we track user engagement in our CRM?", to which I answered "We already use Sentry for Session recording, we can pull that data from the API, aggregate it and push it to the CRM."  Hence this project.  It is currently pretty simple and includes an API as well as basic web ui.


## Tech Stack
- [AdonisJS](https://adonisjs.com): I decided to use the wonderful AdonisJS framework for this project.  Overkill? probably but it has a lot of nicecities built in and I didn't want to reinvent the wheel for this simple project.  I also wanted to play around with InertiaJS which comes included.
- [Docker](https://docker.com) - All services have been containerized for convience of developing, testing and deploying.  A `compose.yml` and `compose.override.yml` are included for testing and developing locally.
- Redis - Some basic caching because why not?
- Postgresql - Useful for storing historical session data.
- Traefik - Reverse Proxy/Ingress controller Provided for convienent development and local testing.
- Grafana - (Optional) For building pretty dashboards.


## Getting started
```shell
$ cp .env.example .env.develop
# Add/edit values in .env.develop as needed
# The WEBHOOK_URL is not strictly necessary for basic functionality.

# Tested on Linux, I have not had the pleasure of setting up Traefik on Windows/Mac
# recently so suggestions welcome.  Also you may need `sudo` depending on how your
# Docker environment is set up.
$ docker compose up -d
```

Once all of the containers come up, you should be able to access the UI/API on [http://sentry.docker.localhost]() (Docker compose magic.)  The database migrations should automatically run when you start with `docker compose` but if you are running the backend with node instead you will need to run `node ace migration:run` after starting the app for the first time.

The main page will list any Replay sessions stored in the database.
![](./docs/assets/homepage.jpg)


[http://sentry.docker.localhost/replays]() will fetch session data from Sentry and store it in the database.  It will also return the results as JSON.
